Microsoft Virtualization Discussions

NetApp PowerShell Toolkit 4.3 released!

Shashanka
15,657 Views

Dear PowerShell community,


We are glad to announce the release of NetApp PowerShell Toolkit version 4.3. This unified release has enhancements for both ONTAP and SANtricity modules.

 

ONTAP PowerShell Module:
The latest release adds upto 2050 cmdlets and provides complete API coverage for ONTAP 9.1 and is backward compatible with previous ONTAP releases.

 

SANtricity PowerShell Module:
The latest release adds upto 285 cmdlets and has the following enhancements: 

  • Provides ability for direct communication with E2800 storage array (SANtricity Web Services Proxy is not required)
  • Advanced Analytics (CPU Utilization, Interface stats, Controller stats)
  • ASUP support
  • Verbose and Windows Event logging support
  • Improved context help with examples
  • Improved error messages

Download the PowerShell Toolkit 4.3 from here


Regards,
NetApp PowerShell Toolkit Team

35 REPLIES 35

JGPSHNTAP
14,644 Views

Nice job.

 

Just want to confirm the number of cdot cmdlets

 

1375

 

I only say that b/c I run get-natoolkitversion and it says 4.1 after upgrade w/out reboot

Shashanka
14,489 Views

It is approximately around 1418 cdot cmdlets

JGPSHNTAP
14,429 Views

get-nchelp.count shows 1375

Shashanka
14,387 Views

You are right, this is due to some issue in help system. I have reported this, and it will be fixed in the upcoming release. Thanks for pointing it out.

markweber
14,362 Views

putting this in the 4.3 thread since it seems to be a version specific issue:

 

this worked fine in the previous version of the toolkit:

Update-NcVol -Query $Query -Attributes $attributeTemplate

 

but in 4.3 FlexGroupVolume is listed as a required parameter - which seems to break the above syntax

 

 

Shashanka
14,306 Views

Thanks for pointing it out. This is an issue and has been reported as a bug.

The 'FlexGroupVolume' parameter is added for ONTAP 9.1 and is inadvertently put as a mandatory parameter. This will be resolved in the next relase.

Till then could you please try a workaround. Modify the command as 

 

Update-NcVol -Query $Query -Attributes $attributeTemplate -FlexGroupVolume:$false

If you are using this command in multiple places, then you can define a custom function named as 'Update-NcVol' at the beginning of the script, which will override the PSTK cmdlet Update-NcVol. Within this custom function, call the PSTK module specific cmdlet.  In this manner you need not change your script at every occurance of this cmdlet. 

function Update-NcVol($query, $attributes)
{
     DataONTAP\Update-NcVol -Query $query -Attributes $attributes -FlexGroupVolume:$false
}

Hope this solves your problem

 

JGPSHNTAP
14,295 Views

I will add this to the 4.3 thread as well.

 

With the new features in later released of powershell, is there a need to use the update-ncvol and build queries.

 

I will admin, I've been using PS toolkit for 7-mode since 1.0 and the building queries and executing the commands is not that 'friendly'.

 

Is there another way that this can be done?

SCOTT_LINDLEY
3,205 Views

Thank you very much for this post. It saved what little hair I have left from extinction. I had just upgraded to WFA 4.1 and couldn't figure out why one of the commands was failing with an error message I'd never seen before. After applying your fix the workflow now runs perfectly.

 

 

Your contribution is greatly appreciated!

Kirand1979
14,128 Views

how can i find their names ?

 

It is approximately around 1418 cdot cmdlets

 

i did get-nchelp ... but only cdots one any easy way to filter 

Shashanka
14,116 Views

@JGPSHNTAP I fear there is no other simpler way. You can try all Set-NcVol   cmdlet to modify few parameters. 

 

 

@Kirand1979

A crude way to do is 

 

Get-Help *-Nc*    # Gets all CDOT cmdlets

(Get-Help *-Nc*).count # Get the CDOT cmdlets count

 

Please wait for the next release, where there will be an easy way to query just the CDOT cmdlets. 

JGPSHNTAP
7,729 Views

^^

 

I will say, i've been disappointed with the flexibility of cDOT cmdlets compared to the 7-mode.  We used to be able to pipe to set very easily.  Now we have to build strings and a query to update.

 

Unless i'm missing something it's not that efficient.

 

 

JIATI0111
7,674 Views

I usaully use this to get the counts since it will not count for those werid cmdlet names from other modules on your computer, such as VMWare PowerCLI, CiscoUCS, Dell, PureStorage, etc... 🙂

 

(get-command -Module DataONTAP).count

 

By the way, I tried to download PSTK 4.3 and it looks like the link is broken at this time.

 

 

JGPSHNTAP
7,631 Views

Since upgrading to 4.3, i'm not getting this on my 7-mode systems with this command

 

 

PS C:\powershell> connect-nacontroller filer -cred domain\userid -https
connect-nacontroller : Connection to filer using HTTPS failed - The request was aborted: Could not create SSL/TLS secur
The error may be resolved by generating a new certificate on the storage controller, with a longer key length.
At line:1 char:1

 

 

This is brand new error.  Any insight would be great

Shashanka
7,618 Views

There has been no changes wrt cmdlet Connect-NaController from past 3 PSTK releases. So this hould not be an issue from the new release. 

The issue seems to be at the client machine or at the controller itself, which is disallowing the SSL/TLS connection. Can you try using http instead of https.

JGPSHNTAP
7,615 Views

Ok, so of course I tried http and that works...

 

and this is only from the new code.

 

This is 4.3, hasn't happened in older versions

Nick_Elliott
7,787 Views

Looks like the version wasn't incremented in the version table

I had run the 4.3 installer, went to check that 4.3 was the the version in use and then uninstalled and reinstalled the toolkit using the 4.3 installer.

 

PS C:\Users\Nick Elliott> (gmo -l DataONTAP).Version

Major  Minor  Build  Revision
-----  -----  -----  --------
4      1      0      -1      



PS C:\Users\Nick Elliott> (gmo -l DataONTAP).Version

PS C:\Users\Nick Elliott> (gmo -l DataONTAP).Version

Major  Minor  Build  Revision
-----  -----  -----  --------
4      1      0      -1      

drwoodberry
6,148 Views

I am getting the same thing when I just installed the latest toolkit.

 

I also ran "get-command -Module DataOntap).count" and it shows 2040.

 

Do you know if the version table is a bug?

asulliva
6,144 Views

The toolkit and module versions will not necessarily match.  The toolkit has both the ONTAP and E-Series modules in it, if either of those modules are updated then the toolkit version is increased.  I believe PSTK 4.3 included a version increase for the E-Series module(s), but not the ONTAP module.

 

Hope that helps.

 

Andrew

If this post resolved your issue, please help others by selecting ACCEPT AS SOLUTION or adding a KUDO.

AlexAtanasov
6,279 Views

"Set-NcSis -EnableInlineDedupe $true" returns "WARNING: EnableInlineDedupe parameter available for Data ONTAP 9.0 and up." which is not true. Inline Dedupe is available since DataONTAP 8.3.2.

 

Is there any workaround for this?

asulliva
6,270 Views

Even though the feature has existed since 8.3.2 the ZAPI wasn't added until 8.4 / 9.0 (ZAPI 1.100), which is what's causing the error.  You can work around this using Invoke-NcSsh.

 

Hope that helps.

 

Andrew

If this post resolved your issue, please help others by selecting ACCEPT AS SOLUTION or adding a KUDO.
Public